module l5p1 (clk, rst, in, peak);

input clk;
input rst;
input [3:0] in;
output [3:0] peak;

wire ge;
reg peak;

four_bits_comp comp(peak, in, ge);

always @ (posedge clk or posedge rst)
begin
   if (rst)
      peak = 4'b0;
   else if (ge)
      peak = in;
end

endmodule 

module four_bits_comp (a, b, ge);

input [3:0] a;
input [3:0] b;
output ge;

wire [3:0] gint;
wire [3:0] eint;

one_bit_comp
	comp3(1'b1, 1'b1, a[3], b[3], gint[3], eint[3]),
	comp2(gint[3], eint[3], a[2], b[2], gint[2], eint[2]),
	comp1(gint[2], eint[2], a[1], b[1], gint[1], eint[1]),
	comp0(gint[1], eint[1], a[0], b[0], gint[0], eint[0]);

assign ge = gint[0] | eint[0];

endmodule

module one_bit_comp (gi, ei, a, b, go, eo);

input gi, ei, a, b;
output go, eo;

reg go, eo;

always @ (gi or ei or a or b)
begin
if (gi == 1'b1) begin
	go = 1'b1;
	eo = 1'b0;
	end
else if (ei == 1'b0) begin
	go = 1'b0;
	eo = 1'b0;
	end
else begin
	go = a & b;
	eo = (~a & ~b) || (a & b);
	end
end

endmodule

