///////////////////////////////////////
//
//	LAB5 : SPRING 03
//
//   Part 2 -- FPGA test of struct_adder
//
////////////////////////////////////////


module user_top (clk_pin, rst_pin, enter_pin, fail_mode, leds, 
		seg1,seg2,seg3,seg4,seg5,seg6,seg7,seg8);

//declare all the ports and all required signals here
input clk_pin;
input rst_pin;
input enter_pin;
input [1:0] fail_mode;
output [6:0] leds;
output [6:0] seg1, seg2, seg3, seg4, seg5, seg6, seg7, seg8;

wire out_a;// this is mapped to your openlock output from your FSM
wire out_b;//this is mapped to your error output from your FSM
wire enter; //this is the output of your debouncing circuit
wire reset; //this is the output of your debouncing circuit

reg go;

wire clk,rst,ent;

wire[15:0] A, B;
wire error, ok;

assign clk = clk_pin;
assign rst = ~rst_pin; // the rst_pin is active low
assign ent = ~enter_pin; //the enter_pin is active low

// the module below contains two posedge detectors
prep_inputs t1(.clk(clk), .reset_in(rst), .reset_out(reset), 
			  .enter_in(ent), .enter_out(enter));


// these modules convert arguments A and B into 7-segment LED format.
bin2LED t20(A[15:12], seg1);
bin2LED t21(A[11:8],  seg2);
bin2LED t22(A[7:4],   seg3);
bin2LED t23(A[3:0],   seg4);

bin2LED t24(B[15:12], seg5);
bin2LED t25(B[11:8],  seg6);
bin2LED t26(B[7:4],   seg7);
bin2LED t27(B[3:0],   seg8);


// ----------------------------------------------------------------------------
// YOU HAVE TO WRITE checker MODULE
//   (1) it must test the adder provided (struct_adder) as described in the
//       lab procedure
//   (2) your module is where the 'struct_adder' is instantiated
//   (3) don't forget to add struct_adder.v into your project, because it
//       contains the stub necessary to "link" with the edf file.
//   (4) don't forget to connect 'fail_mode' to the struct_adder
//   (5) Have fun!
// ----------------------------------------------------------------------------
checker mychecker(.fail_mode(fail_mode),  // (in) fail mode (controlled by SW9[2:1])
		  .clk(clk),              // (in) clk
		  .reset(reset),          // (in) global sync reset
		  .go(go),                // (in) your circuit moves forward when go is asserted
		  .a(A),                  // (out) first argument -- displayed on DD1-4
		  .b(B),                  // (out) second argument-- displayed on DD5-8
		  .error(error),          // (out) indicator that error was found
		  .ok(ok));               // (out) asserted when everything seems ok.


assign leds = {3'b0, fail_mode[1:0], error, ok};

endmodule
