///////////////////////////////////////
//
//	LAB5 : SPRING '03
//
//Use this as the top level view of your circuit.
//Create a module called lock that is instantiated in this module.
//This module is to be instantiated in FPGA.v which will be synthesized and 
//implemented in the target FPGA.
//
////////////////////////////////////////


module user_top (clk_pin, rst_pin, enter_pin, code, leds, 
		seg1,seg2,seg3,seg4,seg5,seg6,seg7,seg8);

//declare all the ports and all required signals here
input clk_pin;
input rst_pin;
input enter_pin;
input [1:0] code;
output [6:0] leds;
output [6:0] seg1, seg2, seg3, seg4, seg5, seg6, seg7, seg8;

wire clk;
wire out; 
wire[2:0] state;
wire enter /* synthesis syn_probe=1 xc_loc="AU15" */;
wire reset; //this is the output of your debouncing circuit
wire rst, ent;

reg[7:0] number;

assign clk = clk_pin;
assign rst = ~rst_pin; // the rst_pin is active low
assign ent = ~enter_pin; //the enter_pin is active low

// ** the module below contains two posedge detectors
prep_inputs t1(.clk(clk), .reset_in(rst), .reset_out(reset), 
						  .enter_in(ent), .enter_out(enter));


bin2LED t20(number[7:4], seg1);
bin2LED t21(number[3:0], seg2);

always @ (posedge clk)
	if (reset)
		number <= 8'b0;
	else if (enter)
		number <= number + 8'b1;

	
endmodule


